uses      app,drivers,scrsav;
type      TMainApp=object(TApplication)
                     constructor Init;
                     procedure Idle;virtual;
                     procedure GetEvent(var E:TEvent);virtual;
                   end;
var        ScreenSaver:PScreenSaver;

{----------------------------------------------------------------------------}
constructor TMainApp.Init;
begin
  Inherited Init;
  ScreenSaver:=New(PScreenSaver,Init(New(PWormScreenSaver,Init),2));
end;

{----------------------------------------------------------------------------}
procedure TMainApp.Idle;
var       E:TEvent;
begin
  Inherited Idle;
  if ScreenSaver<>nil then
    ScreenSaver^.CountDown;
end;

{----------------------------------------------------------------------------}
procedure TMainApp.GetEvent(var E:TEvent);
begin
  Inherited GetEvent(E);
  if E.What<>evNothing then
    if ScreenSaver<>nil then
      if E.What=evKeyDown then
      begin
        if ScreenSaver^.Saving then
          E.What:=evNothing;
        ScreenSaver^.HeartBeat;
      end else
        if E.What and evMouse<>0 then
          ScreenSaver^.HeartBeat;
end;

{----------------------------------------------------------------------------}
var       MainApp:TMainApp;

begin
  MainApp.Init;
  MainApp.Run;
  MainApp.Done;
end.